$white: #fff !default;
$black: #000 !default;
$gray: #7e8299 !default;
$gray-dark: #3f4254 !default;
$variable-prefix: bs- !default; // Deprecated in v5.2.0 for the shorter `$prefix`
$prefix: $variable-prefix !default;
$color-contrast-dark: $black !default;
$color-contrast-light: $white !default;
$btn-hover-bg-shade-amount: 15% !default;
$btn-hover-bg-tint-amount: 15% !default;
$btn-hover-border-shade-amount: 20% !default;
$btn-hover-border-tint-amount: 10% !default;
$btn-active-bg-shade-amount: 20% !default;
$btn-active-bg-tint-amount: 20% !default;
$btn-active-border-shade-amount: 25% !default;
$btn-active-border-tint-amount: 10% !default;
$btn-disabled-opacity: 0.65 !default;
$btn-active-box-shadow: inset 0 3px 5px rgba($black, 0.125) !default;
$min-contrast-ratio: 4.5 !default;

@import "~bootstrap/scss/functions";
@import "~bootstrap/scss/mixins/buttons";

@mixin set-color($name, $color, $color-inverse) {
    .btn-#{$name} {
        @include button-variant($color, $color, $color-inverse);
    }

    .btn.btn-#{$name} {
        color: $color-inverse;
        border-color: $color;
        background-color: $color;
    }

    .btn.btn-#{$name} i.bi,
    .btn.btn-#{$name} i[class*=" fa-"],
    .btn.btn-#{$name} i[class*=" fonticon-"],
    .btn.btn-#{$name} i[class*=" la-"],
    .btn.btn-#{$name} i[class^="fa-"],
    .btn.btn-#{$name} i[class^="fonticon-"],
    .btn.btn-#{$name} i[class^="la-"] {
        color: $color-inverse;
    }

    .btn-check:active + .btn.btn-#{$name} .svg-icon,
    .btn-check:active + .btn.btn-#{$name} i,
    .btn-check:checked + .btn.btn-#{$name} .svg-icon,
    .btn-check:checked + .btn.btn-#{$name} i,
    .btn.btn-#{$name}.active .svg-icon,
    .btn.btn-#{$name}.active i,
    .btn.btn-#{$name}.show .svg-icon,
    .btn.btn-#{$name}.show i,
    .btn.btn-#{$name}:active:not(.btn-active) .svg-icon,
    .btn.btn-#{$name}:active:not(.btn-active) i,
    .btn.btn-#{$name}:focus:not(.btn-active) .svg-icon,
    .btn.btn-#{$name}:focus:not(.btn-active) i,
    .btn.btn-#{$name}:hover:not(.btn-active) .svg-icon,
    .btn.btn-#{$name}:hover:not(.btn-active) i,
    .show > .btn.btn-#{$name} .svg-icon,
    .show > .btn.btn-#{$name} i {
        color: $color-inverse;
    }

    .btn-check:active + .btn.btn-#{$name},
    .btn-check:checked + .btn.btn-#{$name},
    .btn.btn-#{$name}.active,
    .btn.btn-#{$name}.show,
    .btn.btn-#{$name}:active:not(.btn-active),
    .btn.btn-#{$name}:focus:not(.btn-active),
    .btn.btn-#{$name}:hover:not(.btn-active),
    .show > .btn.btn-#{$name} {
        color: $color-inverse;
        border-color: if(
            $color ==$color-contrast-light,
            shade-color($color, $btn-hover-bg-shade-amount),
            tint-color($color, $btn-hover-bg-tint-amount)
        );
        background-color: if(
            $color ==$color-contrast-light,
            shade-color($color, $btn-hover-bg-shade-amount),
            tint-color($color, $btn-hover-bg-tint-amount)
        ) !important;
    }

    .btn-#{$name}.btn-icon .svg-icon,
    .btn-#{$name}.btn-icon i {
        color: $color-inverse;
    }

    .bg-#{$name} {
        background-color: $color;
    }

    .bg-#{$name}-important {
        background-color: $color !important;
    }

    .badge-#{$name} {
        color: $color-inverse;
        background-color: $color;
    }

    .badge-#{$name} i.bi,
    .badge-#{$name} i[class*=" fa-"],
    .badge-#{$name} i[class*=" fonticon-"],
    .badge-#{$name} i[class*=" la-"],
    .badge-#{$name} i[class^="fa-"],
    .badge-#{$name} i[class^="fonticon-"],
    .badge-#{$name} i[class^="la-"] {
        color: $color-inverse;
    }

    .text-#{$name} {
        color: $color !important;
    }
}

// Hard to maintain color with name instead use color code
@include set-color("blue", $color-blue, $color-blue-inverse);
@include set-color("black", $color-black, $color-black-inverse);
@include set-color("chocolate", $color-chocolate, $color-chocolate-inverse);
@include set-color("delft-blue", $color-delft-blue, $color-delft-blue-inverse);
@include set-color("gold", $color-gold, $color-gold-inverse);
@include set-color("gray", $color-gray, $color-gray-inverse);
@include set-color("gray-dark", $color-gray-dark, $color-gray-dark-inverse);
@include set-color("gray-light", $color-gray-light, $color-gray-light-inverse);
@include set-color("green", $color-green, $color-green-inverse);
@include set-color(
    "light-grayish-green",
    $color-light-grayish-green,
    $color-light-grayish-green-inverse
);
@include set-color(
    "light-light-grayish-green",
    $color-light-light-grayish-green,
    $color-light-light-grayish-green-inverse
);
@include set-color("lime", $color-lime, $color-lime-inverse);
@include set-color("mint-green", $color-mint-green, $color-mint-green-inverse);
@include set-color("navy", $color-navy, $color-navy-inverse);
@include set-color(
    "non-photo-blue",
    $color-non-photo-blue,
    $color-non-photo-blue-inverse
);
@include set-color("primary", $color-mint-green, $color-mint-green-inverse);
@include set-color("orange", $color-orange, $color-orange-inverse);
@include set-color("pale-red", $color-pale-red, $color-pale-red-inverse);
@include set-color(
    "light-pale-red",
    $color-light-pale-red,
    $color-light-pale-red-inverse
);
@include set-color("poppy", $color-poppy, $color-poppy-inverse);
@include set-color("purple", $color-purple, $color-purple-inverse);
@include set-color("red", $color-red, $color-red-inverse);
@include set-color(
    "sanguine-brown",
    $color-sanguine-brown,
    $color-sanguine-brown-inverse
);
@include set-color(
    "success",
    $color-non-photo-blue,
    $color-non-photo-blue-inverse
);
@include set-color("ucla-blue", $color-ucla-blue, $color-ucla-blue-inverse);
@include set-color("info", $color-ucla-blue, $color-ucla-blue-inverse);
@include set-color("yellow", $color-yellow, $color-yellow-inverse);
@include set-color("warning", $color-delft-blue, $color-delft-blue-inverse);
@include set-color("e9b7ce", $color-e9b7ce, $color-e9b7ce-inverse);
@include set-color("d3f3f1", $color-d3f3f1, $color-d3f3f1-inverse);
@include set-color("1e4a99", $color-1e4a99, $color-1e4a99-inverse);
@include set-color("c00000", $color-c00000, $color-c00000-inverse);
@include set-color("0070c0", $color-0070c0, $color-0070c0-inverse);
@include set-color("d6dce5", $color-d6dce5, $color-d6dce5-inverse);
@include set-color("002060", $color-002060, $color-002060-inverse);
@include set-color("bc687a", $color-bc687a, $color-bc687a-inverse);
@include set-color("c2e7da", $color-c2e7da, $color-c2e7da-inverse);
